package z5;

import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class Z5e {
   
static int M, N, A, B, C, I;
static int [][] BFScount;
static boolean [][] isActive;
static int [][] nodeRange;

static int [] queue;
static int queueHead, queueTail;
static int visitedCount; 
static int maxRange = 0;
static int maxSize = 0;


static void markActiveCells() {
  for(int y = 0; y < M; y++)
    for(int x = 0; x < N; x++) 
       isActive[y][x] =  ( ((A*y*(x+1) + B*(y+1)*x)  % C) != 0);  
}

static void queueInsert(int y, int x, int bfsCount, boolean isSearch2) {
  if ((y < 0) || (y >= M) || (x < 0) || (x >= N)) return;
  if (isSearch2 &&  (nodeRange[y][x] != maxRange)) return;
  if (isActive[y][x] && (BFScount[y][x] < bfsCount )) {
    BFScount[y][x] = bfsCount;
    queue[queueTail+3] = queue[queueHead]+1;
    queue[queueTail+4] = y;
    queue[queueTail+5] = x;
    queueTail += 3;
  }  
}
  
static int BFS(int y, int x, int maxdist, int bfsCount, boolean isSearch2) {
  
  int xx = x; int yy = y;
  BFScount[y][x] = bfsCount;
  visitedCount = 0;
  queueHead = queueTail = 0;
  queue[0] = 0;
  queue[1] = y;
  queue[2] = x;        
  while (queueHead <= queueTail) {
    if (queue[queueHead] == maxdist) { // return the force;
      visitedCount++;
      queueHead += 3;
      continue;
    }
    // try to append to the q
     y = queue[queueHead+1]; x = queue[queueHead+2];
    queueInsert(y-1, x  , bfsCount, isSearch2);
    queueInsert(y ,  x-1, bfsCount, isSearch2);
    queueInsert(y+1, x  , bfsCount, isSearch2);
    queueInsert(y ,  x+1, bfsCount, isSearch2);
    visitedCount++;
    queueHead += 3;
  }
  
  return visitedCount;
}

static void allNodeRanges() {
  maxRange = 0; 
  int range;
  int bfsCount = 0;
  for(int y = 0; y < M; y++)
    for(int x = 0; x < N; x++) 
      if (isActive[y][x]) {
        bfsCount++;
        range = BFS(y, x, I, bfsCount, false)-1;
        nodeRange[y][x] = range;
        if (maxRange < range) maxRange = range;
      }
}

static void maxSizedArea() {
  int areaSize;
  int bfsCount = M*N+1; // big enough
  for(int y = 0; y < M; y++)
    for(int x = 0; x < N; x++) 
      if (isActive[y][x] && (nodeRange[y][x] == maxRange) 
          && (BFScount[y][x] < bfsCount))  {  // do not search again the same region
        areaSize = BFS(y, x, Integer.MAX_VALUE, bfsCount, true);
        if (maxSize < areaSize) maxSize = areaSize;
      }
}

static void readAndInitAll() throws IOException {
  BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
  StringTokenizer st = new StringTokenizer(br.readLine()); 
  M = Integer.valueOf(st.nextToken());
  N = Integer.valueOf(st.nextToken()); 
  st = new StringTokenizer(br.readLine()); 
  A = Integer.valueOf(st.nextToken());
  B = Integer.valueOf(st.nextToken()); 
  C = Integer.valueOf(st.nextToken());
  st = new StringTokenizer(br.readLine()); 
  I = Integer.valueOf(st.nextToken());
  
  isActive = new boolean[M][N];
  markActiveCells();
  BFScount = new int [M][N];
  nodeRange = new int [M][N];
  queue = new int [M*N*3]; 
}

public static void main(String[] args) throws IOException {
  readAndInitAll() ;
    list(isActive, " ");
  allNodeRanges();
    list(nodeRange, " ");
  maxSizedArea();    
  System.out.printf("%d %d\n",maxRange, maxSize);  
}


static void list(int [][] T, String delim) {
  for(int i = 0; i < T.length ; i++) {
    for(int j = 0; j < T[i].length; j++)
      System.out.printf("%s%2d", delim, T[i][j]);  
    System.out.printf("\n");
  }
  System.out.printf("--------------------------\n");
} 

static void list(boolean [][] T, String delim) {
  for(int i = 0; i < T.length ; i++) {
    for(int j = 0; j < T[i].length; j++)
      System.out.printf("%s%s", delim, T[i][j] ? "." : "X" );  
    System.out.printf("\n");
  }
  System.out.printf("--------------------------\n");
} 

}
